=== books/tools/Makefile ===
include ../Makefile-generic
-include Makefile-deps

# Extra dependencies:

time-dollar-with-gc.cert: time-dollar-with-gc-raw.lsp
