=== books/coi/bags/Makefile ===
include ../../Makefile-generic
BOOKS = basic pick-a-point bind-free-rules cons eric-meta \
        meta neq top two-level two-level-meta extras
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*
