=== books/coi/nary/Makefile ===
include ../../Makefile-generic
BOOKS = nth-rules nary example ordinal-order rewrite-equal-hint
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*
