=== books/coi/osets/Makefile ===
include ../../Makefile-generic
BOOKS = primitives computed-hints instance membership fast outer sort \
	sets set-order quantify map multicons multiappend listsets set-processor conversions extras
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*
