=== books/coi/symbol-fns/Makefile ===
include ../../Makefile-generic
BOOKS = symbol-fns symbol-fns-exports
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*
