=== books/coi/util/Makefile ===
include ../../Makefile-generic
BOOKS = mv-nth iff syntaxp ith fixequiv ifixequiv nfixequiv table \
        good-rewrite-order rewrite-equiv clause-processor defsubtype deffix \
        defdoc defbinding ordinal-order \
        rule-sets-documentation rule-sets  rule-sets-support \
        defun-support defun debug skip-rewrite pseudo-translate \
	in-conclusion implies extra-info extra-info-test ifdef \
        recursion-support
-include Makefile-deps

clean: clean-coi-extras

clean-coi-extras:
	rm -f Makefile.*
