=== debian/changelog ===
acl2 (4.3-3) unstable; urgency=low

  * Bug fix: "unowned file /usr/local/share/texmf/ls-R after purge (policy
    6.8, 9.1.2)", thanks to Andreas Beckmann (Closes: #669380).
  * Bug fix: "FTBFS: | /«PKGBUILDDIR»/books/tools/defsum.c:7456:5: error:
    expected expression before &#39;)&#39; token", thanks to Lucas
    Nussbaum (Closes: #669442).  Build-dep on latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 20 Apr 2012 12:59:26 +0000

acl2 (4.3-2) unstable; urgency=low

  * remove special NO_STRIP for ppc
  * multiply-stacks by 4 on #-native-reloc
  * Bug fix: "Please add support for build-arch and build-indep targets",
    thanks to Niels Thykier (Closes: #647919).

 -- Camm Maguire <camm@debian.org>  Fri, 20 Jan 2012 14:18:55 +0000

acl2 (4.3-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Mon, 09 Jan 2012 21:41:00 +0000
